package org.bitbucket.bradleysmithllc.etlunit.context;

import org.bitbucket.bradleysmithllc.etlunit.parser.ETLTestValueObject;

import java.util.Map;

public interface VariableContext
{
	void declareVariable(String variableName);

	boolean hasVariableBeenDeclared(String variableName);

	void removeVariable(String variableName);

	ETLTestValueObject query(String variablePath);

	ETLTestValueObject getValue(String variableName);

	void setValue(String variableName, ETLTestValueObject value);

	void setStringValue(String variableName, String value);

	void setJSONValue(String variableName, String value);

	void declareAndSetValue(String variableName, ETLTestValueObject value);

	void declareAndSetStringValue(String variableName, String value);

	void declareAndSetJSONValue(String variableName, String value);

	VariableContext createNestedScope();

	VariableContext getEnclosingScope();

	VariableContext getTopLevelScope();

	Map<String, ETLTestValueObject> getMapRepresentation();

	Map<String, Object> getVelocityWrapper();
}