package org.bitbucket.bradleysmithllc.etlunit.feature.logging;

import org.bitbucket.bradleysmithllc.etlunit.parser.ETLTestClass;
import org.bitbucket.bradleysmithllc.etlunit.parser.ETLTestMethod;
import org.bitbucket.bradleysmithllc.etlunit.parser.ETLTestOperation;

import java.io.File;

public class LogFileImpl implements LogFileManager.LogFile
{
	private final String message;
	private final File cachedLog;
	private final File sourceLog;
	private final String classifier;

	private final ETLTestClass testClass;
	private final ETLTestMethod testMethod;
	private final ETLTestOperation testOperation;

	public LogFileImpl(
			String message,
			String classifier,
			File cachedLog,
			File sourceLog,
			ETLTestClass testClass,
			ETLTestMethod testMethod,
			ETLTestOperation testOperation
										)
	{
		this.message = message;
		this.classifier = classifier;
		this.cachedLog = cachedLog;
		this.sourceLog = sourceLog;
		this.testClass = testClass;
		this.testMethod = testMethod;
		this.testOperation = testOperation;
	}

	@Override
	public String getMessage()
	{
		return message;
	}

	@Override
	public File getFile()
	{
		return cachedLog;
	}

	@Override
	public File getOriginalPath()
	{
		return sourceLog;
	}

	@Override
	public ETLTestOperation getTestOperation()
	{
		return testOperation;
	}

	@Override
	public ETLTestMethod getTestMethod()
	{
		return testMethod;
	}

	@Override
	public ETLTestClass getTestClass()
	{
		return testClass;
	}

	public String getClassifier() {
		return classifier;
	}
}