package org.bitbucket.bradleysmithllc.etlunit.parser;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class ETLTestMethodImpl extends ETLTestAnnotatedImpl implements ETLTestMethod
{
	private final String className;
	private final method_type type;

	private final ETLTestClass ETLTestClass;

	private final List<ETLTestOperation> operations = new ArrayList<ETLTestOperation>();
	private final List<ETLTestOperation> operationsPub = Collections.unmodifiableList(operations);

	public ETLTestMethodImpl(String name, method_type mt, ETLTestClass cls)
	{
		className = name;
		type = mt;
		ETLTestClass = cls;
	}

	public ETLTestMethodImpl(String name, method_type mt, ETLTestClass cls, Token t)
	{
		super(t);
		className = name;
		type = mt;
		ETLTestClass = cls;
	}

	public String getName()
	{
		return className;
	}

	@Override
	public String getQualifiedName()
	{
		return ETLTestClass.getQualifiedName() + "." + getName();
	}

	public method_type getMethodType()
	{
		return type;
	}

	public void addOperation(ETLTestOperation op)
	{
		operations.add(op);
	}

	public List<ETLTestOperation> getOperations()
	{
		return operationsPub;
	}

	public boolean requiresPurge()
	{
		return !hasAnnotation("@DoNotPurge");
	}

	public ETLTestClass getTestClass()
	{
		return ETLTestClass;
	}
}